Debian Bug report logs - #114920
[PROPOSAL] remove foolish consistency in perl module names

Package: debian-policy; Maintainer for debian-policy is Debian Policy List <debian-policy@lists.debian.org>; Source for debian-policy is src:debian-policy.

Reported by: Joey Hess <joeyh@debian.org>

Date: Mon, 8 Oct 2001 20:48:02 UTC

Severity: wishlist

Done: Russ Allbery <rra@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: submit@bugs.debian.org
Subject: [PROPOSAL] remove foolish consistency in perl module names
Date: Mon, 8 Oct 2001 16:39:53 -0400
Package: debian-policy

Rationalle:

Perl policy currently dictates that a perl module package have a name of
the form lib-foo-bar-perl, where "foo-bar" maps to Foo:Bar in the perl
module name. This is resulting in a lot of very large and awkward
package names -- the worst ofender so far is the longest named package
in the entire distribution: libbusiness-onlinepayment-bankofamerica-perl

There are a lot of other very long package names that result from this
foolish consistency, and indeed perl module packages make up 1/5th of
all the packages with names in excess of 25 characters. Reducing the
size of these packages names will thus have a large impact on the length
of Debian's package names in general; this in turn has many ramificatons
large and small everywhere users deal with or are exposed to package
names. (Typing in "libbusiness-onlinepayment-bankofamerica-perl" is not
fun. Neither is seeing it truncated to 20 characters in dpkg -l.)

At the same time, this consistency of package names can indeed be very
useful, when things are being automated, and we shouldn't lose that
benefit with foolish inconsistency.


Proposal:

Replace section 3.2 of the perl sub-policy included with Debian policy
with the following text:

    Packages which contain perl modules should provide virtual packages
    that correspond to the primary module or modules in the package. The
    naming convention is that for module 'Foo::Bar', the package should
    provide 'libfoo-bar-perl'. This may be used as the package's name if
    the result is not too long and cumbersome. Or the package's name may
    be an abbreviated version, and the longer name put in the Provides
    field.

Also, although they are not currently part of the formal policy, there
are conventions to use similar naming for java (and maybe python) module
packages, and if this proposal is passed, those informal policies should
be updated to work the same way.


Transition:

There is no need for a transition plan for this proposal. It allows
existing packages to remain unchanged, while new packages use shorter
names as desired. Existing packages can be renamed to shorter names at
their maintainers' discretion, though if they do, they'll have to watch
out for versioned dependancies (rare; very little depends on perl module
packages at all).


Process:

I am looking for seconds for this proposal.

--
      A foolish consistency is the hobgoblin of little minds.
                      -- Ralph Waldo Emerson



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Herbert Xu <herbert@gondor.apana.org.au>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 114920@bugs.debian.org (full text, mbox):

From: Herbert Xu <herbert@gondor.apana.org.au>
To: Joey Hess <joeyh@debian.org>, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Tue, 09 Oct 2001 08:36:56 +1000
Joey Hess <joeyh@debian.org> wrote:
>
> Proposal:

> Replace section 3.2 of the perl sub-policy included with Debian policy
> with the following text:

>    Packages which contain perl modules should provide virtual packages
>    that correspond to the primary module or modules in the package. The
>    naming convention is that for module 'Foo::Bar', the package should
>    provide 'libfoo-bar-perl'. This may be used as the package's name if
>    the result is not too long and cumbersome. Or the package's name may
>    be an abbreviated version, and the longer name put in the Provides
>    field.

I object.  Until versioned provides work reliably, doing this prevents
any use of versioned dependencies on such packages which may come back
to haunt us.
-- 
Debian GNU/Linux 2.2 is out! ( http://www.debian.org/ )
Email:  Herbert Xu ~{PmV>HI~} <herbert@gondor.apana.org.au>
Home Page: http://gondor.apana.org.au/~herbert/
PGP Key: http://gondor.apana.org.au/~herbert/pubkey.txt



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joey@kitenet.net>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 114920@bugs.debian.org (full text, mbox):

From: Joey Hess <joey@kitenet.net>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Mon, 8 Oct 2001 18:56:30 -0400
Herbert Xu wrote:
> I object.  Until versioned provides work reliably, doing this prevents
> any use of versioned dependencies on such packages which may come back
> to haunt us.

If something needs to declare a versioned dependency, it need only use
the package's real name in the dependency. There really arn't that many
dependancies on libfoo-perl packages in debian, and the number of
versioned dependencies is quite small.

Raising the specter of versioned provides sure is a nice way to kill any
forward progress at all, ain't it?

-- 
see shy jo



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Branden Robinson <branden@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 114920@bugs.debian.org (full text, mbox):

From: Branden Robinson <branden@debian.org>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistency in perl module names
Date: Mon, 8 Oct 2001 18:31:23 -0500
[Message part 1 (text/plain, inline)]
On Mon, Oct 08, 2001 at 06:56:30PM -0400, Joey Hess wrote:
> Raising the specter of versioned provides sure is a nice way to kill any
> forward progress at all, ain't it?

What do you think we have Herbert Xu around for?

-- 
G. Branden Robinson                |      The greatest productive force is
Debian GNU/Linux                   |      human selfishness.
branden@debian.org                 |      -- Robert Heinlein
http://people.debian.org/~branden/ |
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to ivan <ivan@420.am>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 114920@bugs.debian.org (full text, mbox):

From: ivan <ivan@420.am>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 01:05:09 -0700
I object to this proposal for the reasons outlined below.  I _do_ agree
with the spirit of the proposal and would support it if the issues below
were resolved.

The amendment should explicitly specify a maximum length rather than the
ambiguous "too long and cumbersome".  This should be a general policy
clarification, not just a perl policy change.

Current perl policy provides an unambiguous mapping from CPAN distribution
name to debian package name, and vice-versa.  If I know the name of the
CPAN module distribution I want, I know the name of the debian package
which provides it.  If I know the name of a debian package, I know the
CPAN module distribution it provides.  I find this *very* useful.  The
amendment as proposed would remove this ability. 

-- 
_ivan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Herbert Xu <herbert@gondor.apana.org.au>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 114920@bugs.debian.org (full text, mbox):

From: Herbert Xu <herbert@gondor.apana.org.au>
To: Joey Hess <joey@kitenet.net>, 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistency in perl module names
Date: Tue, 09 Oct 2001 18:25:01 +1000
Joey Hess <joey@kitenet.net> wrote:
> Herbert Xu wrote:
>> I object.  Until versioned provides work reliably, doing this prevents
>> any use of versioned dependencies on such packages which may come back
>> to haunt us.

> If something needs to declare a versioned dependency, it need only use
> the package's real name in the dependency. There really arn't that many

You're right.  Consider the objection withdrawn.
-- 
Debian GNU/Linux 2.2 is out! ( http://www.debian.org/ )
Email:  Herbert Xu ~{PmV>HI~} <herbert@gondor.apana.org.au>
Home Page: http://gondor.apana.org.au/~herbert/
PGP Key: http://gondor.apana.org.au/~herbert/pubkey.txt



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Andrew Suffield <asuffield@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 114920@bugs.debian.org (full text, mbox):

From: Andrew Suffield <asuffield@debian.org>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 11:11:44 +0100
On Tue, Oct 09, 2001 at 01:05:09AM -0700, ivan wrote:
> Current perl policy provides an unambiguous mapping from CPAN distribution
> name to debian package name, and vice-versa.  If I know the name of the
> CPAN module distribution I want, I know the name of the debian package
> which provides it.  If I know the name of a debian package, I know the
> CPAN module distribution it provides.  I find this *very* useful.  The
> amendment as proposed would remove this ability. 

I suggest the amendment require that the package Provide the full
name, if it doesn't use it as its real name.

-- 
  .''`.  ** Debian GNU/Linux ** | Andrew Suffield
 : :' :                         | Dept. of Computing,
 `. `'                          | Imperial College,
   `-    http://www.debian.org/ | London, UK




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Sam Hartman <hartmans@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 114920@bugs.debian.org (full text, mbox):

From: Sam Hartman <hartmans@debian.org>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: 09 Oct 2001 11:20:31 -0400
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

>>>>> "jh" == Joey Hess <joeyh@debian.org> writes:
    jh> Proposal:

    jh> Replace section 3.2 of the perl sub-policy included with Debian policy
    jh> with the following text:

    jh>     Packages which contain perl modules should provide virtual packages
    jh>     that correspond to the primary module or modules in the package. The
    jh>     naming convention is that for module 'Foo::Bar', the package should
    jh>     provide 'libfoo-bar-perl'. This may be used as the package's name if
    jh>     the result is not too long and cumbersome. Or the package's name may
    jh>     be an abbreviated version, and the longer name put in the Provides
    jh>     field.

Second.  I'd also second with a clarification about the primary CPAN
distribution as Andrew mentions.  I don't think that sspecifying a
specific maximum length is such a good idea because I don't see a need
for policy to specify that.  It may depend on how the package is used,
who is likely to install it, etc.
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.6 (GNU/Linux)
Comment: Processed by Mailcrypt 3.5.6 and Gnu Privacy Guard <http://www.gnupg.org/>

iEYEARECAAYFAjvDFZ0ACgkQ/I12czyGJg+F7QCg4RVk43pIOJThvpSjueBNFIBL
SDcAoMBEOlc+Iw+ae44jJDaBr+T3GRP2
=hvpS
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #45 received at 114920@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@debian.org>
To: Andrew Suffield <asuffield@debian.org>, 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 10:37:25 -0500
On Tue, Oct 09, 2001 at 11:11:44AM +0100, Andrew Suffield wrote:
> On Tue, Oct 09, 2001 at 01:05:09AM -0700, ivan wrote:
> > Current perl policy provides an unambiguous mapping from CPAN distribution
> > name to debian package name, and vice-versa.  If I know the name of the
> > CPAN module distribution I want, I know the name of the debian package
> > which provides it.  If I know the name of a debian package, I know the
> > CPAN module distribution it provides.  I find this *very* useful.  The
> > amendment as proposed would remove this ability. 
> 
> I suggest the amendment require that the package Provide the full
> name, if it doesn't use it as its real name.

It already does.

-- 
Colin Watson                                  [cjwatson@flatline.org.uk]



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Andrew Suffield <asuffield@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #50 received at 114920@bugs.debian.org (full text, mbox):

From: Andrew Suffield <asuffield@debian.org>
To: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 17:53:20 +0100
On Tue, Oct 09, 2001 at 10:37:25AM -0500, Colin Watson wrote:
> On Tue, Oct 09, 2001 at 11:11:44AM +0100, Andrew Suffield wrote:
> > On Tue, Oct 09, 2001 at 01:05:09AM -0700, ivan wrote:
> > > Current perl policy provides an unambiguous mapping from CPAN distribution
> > > name to debian package name, and vice-versa.  If I know the name of the
> > > CPAN module distribution I want, I know the name of the debian package
> > > which provides it.  If I know the name of a debian package, I know the
> > > CPAN module distribution it provides.  I find this *very* useful.  The
> > > amendment as proposed would remove this ability. 
> > 
> > I suggest the amendment require that the package Provide the full
                            ^^^^^^^
> > name, if it doesn't use it as its real name.
> 
> It already does.

It currently suggests it:

>   Or the package's name may
>   be an abbreviated version, and the longer name put in the Provides
>   field.

Require is probably too strong, but I suggest this should instead read:

    or the package's name may be abbreviated. If the package does not
    use the full name, it should include the full name in the Provides
    field.

-- 
  .''`.  ** Debian GNU/Linux ** | Andrew Suffield
 : :' :                         | Dept. of Computing,
 `. `'                          | Imperial College,
   `-    http://www.debian.org/ | London, UK




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #55 received at 114920@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: ivan <ivan@420.am>, 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 13:31:33 -0400
ivan wrote:
> I object to this proposal for the reasons outlined below.  I _do_ agree
> with the spirit of the proposal and would support it if the issues below
> were resolved.
> 
> The amendment should explicitly specify a maximum length rather than the
> ambiguous "too long and cumbersome".  This should be a general policy
> clarification, not just a perl policy change.

Policy is only useful if the reader applies common sense when reading
it. 10 characters may be "too long and cumbersome" for a very often-used
perl module package which people install by hand, while 30 characters is
not overly long for a very special-purpose perl module package that is
only ever pulled in by dependancies.

I might support a general proposal for an absolute upper bound on
package name size, but that would be another proposal (feel free to make
it, I'm sure the flame war would be interesting). And I would want my
"too long and cumbersome" text to remain nontheless, as its purpose is
*not* to enforce an absolute upper bound on package name suze, but to
make the maintainer *think*, "is this package name going to be too long
and cumbersome?".

I think that getting people to think often results in better systems than
just forcing them to memorize a pile of rules.

> Current perl policy provides an unambiguous mapping from CPAN distribution
> name to debian package name, and vice-versa.  If I know the name of the
> CPAN module distribution I want, I know the name of the debian package
> which provides it.  If I know the name of a debian package, I know the
> CPAN module distribution it provides.  I find this *very* useful.  The
> amendment as proposed would remove this ability. 

It seems you missed the fact that provides will allow the CPAN -> package
mapping. The reverse mapping is IMHO not too useful. Provide a few examples
of when you'd need to be able to do that mapping automatically, please.

Also, bear in mind that this reverse mapping you're so keen on is not
required by current debian perl policy[1]. Imagine a package that
contains 3 perl modules, Foo::Bar, Foo::Baz, and Xyzzy. Foo::Bar is, in
the eyes of the maintainer (but maybe not in the eyes of the user) the
"primary module provided", so the package is named libfoo-bar-perl. The
maintainer, following current perl policy, decides to go ahead and make
it provide libfoo-baz-perl and libxyzzy-perl as well. Now given the
name of the libfoo-bar-perl package, how do you automatically know the
CPAN modules it provides? You don't; you know at most one of them.

-- 
see shy jo

[1] Which is:

     Perl module packages should be named for the primary module provided.
     The naming convention for module `Foo::Bar' is `libfoo-bar-perl'.
     Packages which include multiple modules may additionally include
     provides for those modules using the same convention.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #60 received at 114920@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Andrew Suffield <asuffield@debian.org>, 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 13:35:06 -0400
Andrew Suffield wrote:
> > > I suggest the amendment require that the package Provide the full
>                             ^^^^^^^
> > > name, if it doesn't use it as its real name.
> > 
> > It already does.
> 
> It currently suggests it:
> 
> >   Or the package's name may
> >   be an abbreviated version, and the longer name put in the Provides
> >   field.
> 
> Require is probably too strong, but I suggest this should instead read:
> 
>     or the package's name may be abbreviated. If the package does not
>     use the full name, it should include the full name in the Provides
>     field.

I have no problem with that wording, but I fail to see how it is any
different from the original wording. My original wording doesn't say
"and the longer name OPTIONALLY put in the Provides field", it says you
can abbreviate the name AND put the longer name in the provides field.

-- 
see shy jo



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to ivan <ivan@420.am>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #65 received at 114920@bugs.debian.org (full text, mbox):

From: ivan <ivan@420.am>
To: Joey Hess <joeyh@debian.org>
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 11:56:22 -0700
On Tue, Oct 09, 2001 at 01:31:33PM -0400, Joey Hess wrote:
> ivan wrote:
> > I object to this proposal for the reasons outlined below.  I _do_ agree
> > with the spirit of the proposal and would support it if the issues below
> > were resolved.
> > 
> > The amendment should explicitly specify a maximum length rather than the
> > ambiguous "too long and cumbersome".  This should be a general policy
> > clarification, not just a perl policy change.
> 
> Policy is only useful if the reader applies common sense when reading
> it. 10 characters may be "too long and cumbersome" for a very often-used
> perl module package which people install by hand, while 30 characters is
> not overly long for a very special-purpose perl module package that is
> only ever pulled in by dependancies.

> I might support a general proposal for an absolute upper bound on
> package name size, but that would be another proposal (feel free to make
> it, I'm sure the flame war would be interesting).

I very well may; after uploading the longest package in the distribution
the irony of proposing that amendment might be too much to pass up.  First
you'd have to convince me mapping problems below are fixed or fixable, I
think. 

> And I would want my
> "too long and cumbersome" text to remain nontheless, as its purpose is
> *not* to enforce an absolute upper bound on package name suze, but to
> make the maintainer *think*, "is this package name going to be too long
> and cumbersome?".
> 
> I think that getting people to think often results in better systems than
> just forcing them to memorize a pile of rules.

In this specific case, if the problem below is not solved, an explicit
maximum length would at least let the person searching for the .deb
package that corresponds to a CPAN distribution name know when to stop
looking for libfoo-too-long-bar-perl and to start looking for an
abbriviated package name.  If the problem below is not solved,
specifying an explicit maximum length and a standard abbriviation method
will at least make it possible (if more cumbersome) to find the debian
package for a particular CPAN distribution name.

(If the problem were to be solved, then this is irrelevant)

> > Current perl policy provides an unambiguous mapping from CPAN distribution
> > name to debian package name, and vice-versa.  If I know the name of the
> > CPAN module distribution I want, I know the name of the debian package
> > which provides it.  If I know the name of a debian package, I know the
> > CPAN module distribution it provides.  I find this *very* useful.  The
> > amendment as proposed would remove this ability. 
> 
> It seems you missed the fact that provides will allow the CPAN -> package
> mapping.

I was not sufficiently clear in my wording if what you got from it was
that I missed this fact.

Provides: will allow the CPAN->package mapping for *dependencies*.  There
is no provision for "/" in dselect (or the equivalent in other package
managers) or `apt-get install libfoo-bar-perl'.  This is something I do
*often*, and I'd say that other Perl programmers who have switched from
CPAN to .deb for their module need do also.  At a minimum, you'd want
something to grovel through the Provides: so you can do something not
unlike: 
	apt-get install `cpan2deb Foo::Bar`
for proof-of-concept.

 "/" in dselect and search in other package managers is an acceptable
casualty to me, but it should be mentioned.  If I were being really
pie-in-the-sky I'd wish for the ability to search for Perl (Java,
Python, etc.) names with a special option (or just "/") in dselect,
and an equivalent in other package managers.

> The reverse mapping is IMHO not too useful. Provide a few examples
> of when you'd need to be able to do that mapping automatically, please.

I find it useful to do manually, and I disagree that automatic usage is
the only useful use.

An example of where it is useful to have this one-to-one mapping: 
Consider the case where I find a Perl application I like/find
useful/whatever on my desktop box running unstable or testing.  The
application is not yet in stable.  I then wish to install this application
on box running Debian stable or a non-debian OS.  To determine which CPAN 
distributions I need, I can currently look at the Depends: of the package
to determine this information unambiguously.

(Tangential but relevant: the build procedure of most modules is no longer
compatible with stable; most of them no longer build on stable.
Therefore when installing an application from unstable/testing on stable, 
backporting modules from unstable is far more complicated than CPAN and
*not* a matter of a simple apt-get source and dpkg-buildpackage)

The amendment as proposed breaks the ability to determine this
information.  Given the Depends: example from the above paragraph, how
would you determine if a lib-*-perl module was an abbriviated name or not? 
How would you determine which Provides: in the package description
corresponds to the CPAN distibution name? (note that CPAN distribution
name != CPAN module name in all cases - more on that below). 

> Also, bear in mind that this reverse mapping you're so keen on is not
> required by current debian perl policy[1]. Imagine a package that
> contains 3 perl modules, Foo::Bar, Foo::Baz, and Xyzzy. Foo::Bar is, in
> the eyes of the maintainer (but maybe not in the eyes of the user) the
> "primary module provided", so the package is named libfoo-bar-perl. The
> maintainer, following current perl policy, decides to go ahead and make
> it provide libfoo-baz-perl and libxyzzy-perl as well. Now given the
> name of the libfoo-bar-perl package, how do you automatically know the
> CPAN modules it provides? You don't; you know at most one of them.

Actually (and here policy is out of sync with reality and should be fixed
- a separate problem), debian packages are typically named
after the CPAN _distribution name_, not the _module name_. 

Two examples are libcgi-pm-perl and libmailtools-perl.  libcgi-pm-perl
provides the CGI module, not the CGI::PM module, but it is correctly named
libcgi-pm-perl after the CGI.pm CPAN distribution: 
http://search.cpan.org/search?dist=CGI.pm

libmailtools-perl provides a bunch of Mail:: modules such as Mail::Send,
Mail::Address and Mail::Internet, not the MailTools module or MailTools:: 
modules.  Again, it correctly named after the MailTools CPAN distribution: 
http://search.cpan.org/search?dist=MailTools

You've also mixed them up a bit reading my objections; understandable,
considering the confusion of current policy on this issue.  Above I'm
talking about one-to-one correspondance between debian package name and
CPAN distribution name, *not* module name.

> [1] Which is:
> 
>      Perl module packages should be named for the primary module provided.
>      The naming convention for module `Foo::Bar' is `libfoo-bar-perl'.
>      Packages which include multiple modules may additionally include
>      provides for those modules using the same convention.

-- 
_ivan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joey@kitenet.net>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #70 received at 114920@bugs.debian.org (full text, mbox):

From: Joey Hess <joey@kitenet.net>
To: ivan <ivan@420.am>
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 15:56:00 -0400
ivan wrote:
> Provides: will allow the CPAN->package mapping for *dependencies*.  There
> is no provision for "/" in dselect (or the equivalent in other package
> managers) or `apt-get install libfoo-bar-perl'.

Apt will honour provides when installing a package.

root@silk:/home/joey>apt-get install libmail-perl
Reading Package Lists... Done
Building Dependency Tree... Done
Note, selecting libmailtools-perl instead of libmail-perl

As for dselect, all this needs is full-text-search of package
descriptions in dselect (which is implemented already, and in CVS I
think), and then mentioning what modules are provided in the
description.

>  "/" in dselect and search in other package managers is an acceptable
> casualty to me, but it should be mentioned.

Ok, consider it mentioned (or do you mean mention it in policy?).

> An example of where it is useful to have this one-to-one mapping: 
> Consider the case where I find a Perl application I like/find
> useful/whatever on my desktop box running unstable or testing.  The
> application is not yet in stable.  I then wish to install this application
> on box running Debian stable or a non-debian OS.  To determine which CPAN 
> distributions I need, I can currently look at the Depends: of the package
> to determine this information unambiguously.

... As opposed to, say, downloading the application on the
non-debian/stable system and following its regular installation
instructions.

I think this is out of scope of the purpose of debian package names, and
if it's the best you can do, I don't think it's worth shooting down this
porposal for.

> Actually (and here policy is out of sync with reality and should be fixed
> - a separate problem), debian packages are typically named
> after the CPAN _distribution name_, not the _module name_. 

That's a good point and I guess we should fix that in the perl policy.

-- 
see shy jo



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to ivan <ivan@420.am>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #75 received at 114920@bugs.debian.org (full text, mbox):

From: ivan <ivan@420.am>
To: Joey Hess <joey@kitenet.net>
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Tue, 9 Oct 2001 13:47:27 -0700
On Tue, Oct 09, 2001 at 03:56:00PM -0400, Joey Hess wrote:
> As for dselect, all this needs is full-text-search of package
> descriptions in dselect (which is implemented already, and in CVS I
> think), and then mentioning what modules are provided in the
> description.

Okay, please add the description requirement to the amendment proposal.

It's still quite prone to false-positives unlike the current convention (a
distinct search of packgage name || Provides: would be preferable).  But I
don't think this reason alone are worth an objection to this policy
change.

> >  "/" in dselect and search in other package managers is an acceptable
> > casualty to me, but it should be mentioned.
> 
> Ok, consider it mentioned (or do you mean mention it in policy?).

Just here.  If it bothers someone else more than I they are welcome to
speak up. 

-- 
_ivan



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Andrew Suffield <asuffield@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #80 received at 114920@bugs.debian.org (full text, mbox):

From: Andrew Suffield <asuffield@debian.org>
To: Joey Hess <joeyh@debian.org>
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Wed, 10 Oct 2001 16:30:36 +0100
[Message part 1 (text/plain, inline)]
On Tue, Oct 09, 2001 at 01:35:06PM -0400, Joey Hess wrote:
> > >   Or the package's name may
                              ^^^
> > >   be an abbreviated version, and the longer name put in the Provides
> > >   field.
> > 
> > Require is probably too strong, but I suggest this should instead read:
> > 
> >     or the package's name may be abbreviated. If the package does not
                              ^^^
> >     use the full name, it should include the full name in the Provides
                              ^^^^^^
> >     field.
> 
> I have no problem with that wording, but I fail to see how it is any
> different from the original wording. My original wording doesn't say
> "and the longer name OPTIONALLY put in the Provides field", it says you
> can abbreviate the name AND put the longer name in the provides field.

Actually it does say that, although I don't think you meant it that
way. The original wording captures the Provides bit under a 'may'
clause; I have moved it to a 'should' clause.

Policy 1.1: 

In this manual, the words must, should and may, and the adjectives
required, recommended and optional, are used to distinguish the
significance of the various guidelines in this policy
document. Packages that do not conform to the guidelines denoted by
must (or required) will generally not be considered acceptable for the
Debian distribution. Non-conformance with guidelines denoted by should
(or recommended) will generally be considered a bug, but will not
necessarily render a package unsuitable for distribution. Guidelines
denoted by may (or optional) are truly optional and adherence is left
to the maintainer's discretion.

-- 
  .''`.  ** Debian GNU/Linux ** | Andrew Suffield
 : :' :                         | Dept. of Computing,
 `. `'                          | Imperial College,
   `-    http://www.debian.org/ | London, UK
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #85 received at 114920@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Andrew Suffield <asuffield@debian.org>
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: PROPOSAL] remove foolish consistence in perl module names
Date: Wed, 10 Oct 2001 13:49:20 -0400
Andrew Suffield wrote:
> On Tue, Oct 09, 2001 at 01:35:06PM -0400, Joey Hess wrote:
> > > >   Or the package's name may
>                               ^^^
> > > >   be an abbreviated version, and the longer name put in the Provides
> > > >   field.
> > > 
> > > Require is probably too strong, but I suggest this should instead read:
> > > 
> > >     or the package's name may be abbreviated. If the package does not
>                               ^^^
> > >     use the full name, it should include the full name in the Provides
>                               ^^^^^^
> > >     field.
> > 
> > I have no problem with that wording, but I fail to see how it is any
> > different from the original wording. My original wording doesn't say
> > "and the longer name OPTIONALLY put in the Provides field", it says you
> > can abbreviate the name AND put the longer name in the provides field.
> 
> Actually it does say that, although I don't think you meant it that
> way. The original wording captures the Provides bit under a 'may'
> clause; I have moved it to a 'should' clause.

My original wording uses a may clause for the conjunction consiting of
(abbreviated_name && full_name_in_provides_field). You can't get away
with just doing one. At least that's the way I use the English language.
If you really think it's unclear I have no problem with your wording.

-- 
see shy jo



Severity set to `wishlist'. Request was from Manoj Srivastava <srivasta@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #92 received at 114920@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 114920@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Tue, 01 Jan 2008 18:28:46 -0800
This is a Policy proposal that's sat in the Policy bug queue with wording
and seconds for quite some time.  I'd like to resurrect it and resolve it
one way or the other.

Since this is a change to the Perl packaging policy, specifically for Perl
modules, I'm cc'ing the debian-perl list, as the most likely available set
of experts in this area.

I'm quoting the full original proposal to keep people from having to go to
bugs.debian.org for it.

My reading of the bug log was that this proposal previously reached
consensus, but applying six-year-old changes based on a previous consensus
is usually a bad idea.  I'm personally indifferent.  (In many cases, I'm
not sure what the useful abbreviation for the package name would be, but
that would be up to the maintainer.)

Joey Hess <joeyh@debian.org> writes:

> Rationalle:
>
> Perl policy currently dictates that a perl module package have a name of
> the form lib-foo-bar-perl, where "foo-bar" maps to Foo:Bar in the perl
> module name. This is resulting in a lot of very large and awkward
> package names -- the worst ofender so far is the longest named package
> in the entire distribution: libbusiness-onlinepayment-bankofamerica-perl
>
> There are a lot of other very long package names that result from this
> foolish consistency, and indeed perl module packages make up 1/5th of
> all the packages with names in excess of 25 characters. Reducing the
> size of these packages names will thus have a large impact on the length
> of Debian's package names in general; this in turn has many ramificatons
> large and small everywhere users deal with or are exposed to package
> names. (Typing in "libbusiness-onlinepayment-bankofamerica-perl" is not
> fun. Neither is seeing it truncated to 20 characters in dpkg -l.)
>
> At the same time, this consistency of package names can indeed be very
> useful, when things are being automated, and we shouldn't lose that
> benefit with foolish inconsistency.
>
>
> Proposal:
>
> Replace section 3.2 of the perl sub-policy included with Debian policy
> with the following text:
>
>     Packages which contain perl modules should provide virtual packages
>     that correspond to the primary module or modules in the package. The
>     naming convention is that for module 'Foo::Bar', the package should
>     provide 'libfoo-bar-perl'. This may be used as the package's name if
>     the result is not too long and cumbersome. Or the package's name may
>     be an abbreviated version, and the longer name put in the Provides
>     field.
>
> Also, although they are not currently part of the formal policy, there
> are conventions to use similar naming for java (and maybe python) module
> packages, and if this proposal is passed, those informal policies should
> be updated to work the same way.
>
>
> Transition:
>
> There is no need for a transition plan for this proposal. It allows
> existing packages to remain unchanged, while new packages use shorter
> names as desired. Existing packages can be renamed to shorter names at
> their maintainers' discretion, though if they do, they'll have to watch
> out for versioned dependancies (rare; very little depends on perl module
> packages at all).

-- 
Russ Allbery (rra@stanford.edu)             <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to "Martín Ferrari" <martin.ferrari@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #97 received at 114920@bugs.debian.org (full text, mbox):

From: "Martín Ferrari" <martin.ferrari@gmail.com>
To: "Russ Allbery" <rra@debian.org>
Cc: 114920@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 00:58:12 -0200
Hi,

On Jan 2, 2008 12:28 AM, Russ Allbery <rra@debian.org> wrote:
> This is a Policy proposal that's sat in the Policy bug queue with wording
> and seconds for quite some time.  I'd like to resurrect it and resolve it
> one way or the other.

I think the proposal is a good technical solution to the problem: I
really want to still be able to apt-get install
libbusiness-onlinepayment-bankofamerica-perl, I don't need to think
twice to find it.

But, is this really a problem? I don't completely grasp the benefit of
using reduced names for libraries. Also, there is the problem of
assigning good names. Perl modules usually don't have fancy names,
saving a couple of distributions. For XS wrappers of C libraries, it
could just use the name of the C library plus -perl, but what about
the rest of CPAN?

And I find the lack of a lib prefix (like the python people do) ugly.

Call me a consistency freak :)

-- 
Martín Ferrari




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregor+debian@comodo.priv.at>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #102 received at 114920@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregor+debian@comodo.priv.at>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 14:33:31 +0100
[Message part 1 (text/plain, inline)]
On Wed, 02 Jan 2008 00:58:12 -0200, Martín Ferrari wrote:

> On Jan 2, 2008 12:28 AM, Russ Allbery <rra@debian.org> wrote:
> > This is a Policy proposal that's sat in the Policy bug queue with wording
> > and seconds for quite some time.  I'd like to resurrect it and resolve it
> > one way or the other.
> I think the proposal is a good technical solution to the problem: I
> really want to still be able to apt-get install
> libbusiness-onlinepayment-bankofamerica-perl, I don't need to think
> twice to find it.

Count me in -- I appreciate the simple mapping of Foo::Bar to
libfoo-bar-perl, too.
 
> But, is this really a problem? I don't completely grasp the benefit of
> using reduced names for libraries. Also, there is the problem of
> assigning good names. 

Ack.

But I don't oppose to the policy change, as long as the "fancy" names
are optional and the "real" names are required to be in a Provides
field (and that's the way I read the proposal).

> Call me a consistency freak :)

Call me more conservative than I'd like to be :)

Cheers,
gregor 
 
-- 
 .''`.   http://info.comodo.priv.at/ | gpg key ID: 0x00F3CFE4
 : :' :  debian: the universal operating system - http://www.debian.org/
 `. `'   member of https://www.vibe.at/ | how to reply: http://got.to/quote/
   `-    NP: Dire Straits: Money For Nothing
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joerg Jaspert <joerg@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #107 received at 114920@bugs.debian.org (full text, mbox):

From: Joerg Jaspert <joerg@debian.org>
To: Russ Allbery <rra@debian.org>
Cc: 114920@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 02 Jan 2008 18:58:33 +0100
[Message part 1 (text/plain, inline)]
>>     Packages which contain perl modules should provide virtual packages
>>     that correspond to the primary module or modules in the package. The
>>     naming convention is that for module 'Foo::Bar', the package should
>>     provide 'libfoo-bar-perl'. This may be used as the package's name if
>>     the result is not too long and cumbersome. Or the package's name may
>>     be an abbreviated version, and the longer name put in the Provides
>>     field.

I dont see a benefit in this at all. It just adds confusion for the sake
of "short package names". Especially as you shouldnt (build)-depend on
virtual packages, so those would need to use the shorter names
too. Having the direct "x::y is libx-y-perl" is IMO more important than
less to type in.

-- 
bye Joerg
http://meta.wikimedia.org/wiki/How_to_win_an_argument
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Julian Mehnle <julian@mehnle.net>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #112 received at 114920@bugs.debian.org (full text, mbox):

From: Julian Mehnle <julian@mehnle.net>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 18:29:47 +0000
[Message part 1 (text/plain, inline)]
Russ Allbery wrote:
> This is a Policy proposal that's sat in the Policy bug queue with
> wording and seconds for quite some time.  I'd like to resurrect it and
> resolve it one way or the other.

There's some room for clarification here.

I think it is apparent from comments given in 2001 the that the policy 
wish-bug under debate concerns the _binary_ package name, and not the 
_source_ package name.  The Debian policy however isn't entirely clear on 
whether it intends to mandate the source or binary package name or both.  
Let me repeat its current text:

| 4.2 Module Package Names
|
| Perl module packages should be named for the primary module provided.
| The naming convention for module Foo::Bar is libfoo-bar-perl. Packages
| which include multiple modules may additionally include provides for
| those modules using the same convention.

I think that from the final sentence it can be inferred that it primarily 
intends to mandate the _binary_ package name.  So while we're discussing 
the binary package naming, maybe we can decide whether the mandate should 
be extended to the _source_ package name as well while we're at it, and 
clarify the Perl policy to explicitly state whether or not the source 
package name is covered by the policy's recommendation.

I know the question of source package naming for Perl modules has been 
discussed on debian-perl before, but that was just about the Debian Perl 
Group's own conventions, not about the global Perl policy.  The Perl 
Group can still maintain stricter conventions even if the Perl policy 
gets relaxed with regard to source package names.

As far as _binary_ package names are concerned, I think they should follow 
an automatable pattern (i.e. the Perl policy's recommendation for binary 
package names should stay as it is).  Long package names are a non-issue 
given Bash completion and package managers with incremental search 
features.

As for _source_ package names, I think they should be free-form.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Message #115 received at 114920@bugs.debian.org (full text, mbox):

From: Don Armstrong <don@debian.org>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 15:46:02 -0800
On Wed, 02 Jan 2008, Julian Mehnle wrote:
> I think that from the final sentence it can be inferred that it primarily 
> intends to mandate the _binary_ package name.  So while we're discussing 
> the binary package naming, maybe we can decide whether the mandate should 
> be extended to the _source_ package name as well while we're at it, and 
> clarify the Perl policy to explicitly state whether or not the source 
> package name is covered by the policy's recommendation.

Unless there's a compelling reason to the contrary, a source package
should in general build at least one binary package of the same name.
This is definetly the case when the source package only builds one
binary package.

The reasons why you want to do this is because everyone knows what the
binary package name is, but it's sometimes difficult to map to a
source package, and it prevents the insanity of Source: foo building
Binary: bar, and Source: bar buildling Binary: foo. (Yes, there is at
least one set of packages in the archive that does this.)
 

Don Armstrong

-- 
If you wish to strive for peace of soul, then believe; if you wish to
be a devotee of truth, then inquire.
 -- Friedrich Nietzsche

http://www.donarmstrong.com              http://rzlab.ucr.edu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #120 received at 114920@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: debian-policy@lists.debian.org, debian-perl@lists.debian.org
Cc: 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 17:09:36 -0800
On Wed, Jan 02, 2008 at 03:46:02PM -0800, Don Armstrong wrote:
> On Wed, 02 Jan 2008, Julian Mehnle wrote:
> > I think that from the final sentence it can be inferred that it primarily 
> > intends to mandate the _binary_ package name.  So while we're discussing 
> > the binary package naming, maybe we can decide whether the mandate should 
> > be extended to the _source_ package name as well while we're at it, and 
> > clarify the Perl policy to explicitly state whether or not the source 
> > package name is covered by the policy's recommendation.

> Unless there's a compelling reason to the contrary, a source package
> should in general build at least one binary package of the same name.
> This is definetly the case when the source package only builds one
> binary package.

Not that this is applicable to perl packages, but one very common reason for
this to not be the case is that the package is a library...  In that case,
it's beneficial to have continuity of the source package name whereas the
binary package name will change periodically.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Julian Mehnle <julian@mehnle.net>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #125 received at 114920@bugs.debian.org (full text, mbox):

From: Julian Mehnle <julian@mehnle.net>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Thu, 3 Jan 2008 01:23:48 +0000
[Message part 1 (text/plain, inline)]
Don Armstrong wrote:
> On Wed, 02 Jan 2008, Julian Mehnle wrote:
> > I think that from the final sentence it can be inferred that it
> > primarily intends to mandate the _binary_ package name.  So while
> > we're discussing the binary package naming, maybe we can decide
> > whether the mandate should be extended to the _source_ package name
> > as well while we're at it, and clarify the Perl policy to explicitly
> > state whether or not the source package name is covered by the
> > policy's recommendation.
>
> Unless there's a compelling reason to the contrary, a source package
> should in general build at least one binary package of the same name.
> This is definetly the case when the source package only builds one
> binary package.

According to a simple survey of the packages in Lenny/amd64 (main, 
contrib, non-free), 2365 of the 11757 source packages (20%!) have no 
binary package of the same name.  814 of these (7% of all) have only a 
single binary package.  Wanna mass-file bugs?  Or maybe the reason 
doesn't have to be all that compelling.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Don Armstrong <don@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #130 received at 114920@bugs.debian.org (full text, mbox):

From: Don Armstrong <don@debian.org>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 17:42:53 -0800
On Wed, 02 Jan 2008, Steve Langasek wrote:
> On Wed, Jan 02, 2008 at 03:46:02PM -0800, Don Armstrong wrote:
> > Unless there's a compelling reason to the contrary, a source
> > package should in general build at least one binary package of the
> > same name. This is definetly the case when the source package only
> > builds one binary package.
> 
> Not that this is applicable to perl packages, but one very common
> reason for this to not be the case is that the package is a
> library... In that case, it's beneficial to have continuity of the
> source package name whereas the binary package name will change
> periodically.

Right; that's exactly the major compelling reason that I was thinking
about when I wrote the above.


Don Armstrong

-- 
There is no such thing as "social gambling." Either you are there to
cut the other bloke's heart out and eat it--or you're a sucker. If you
don't like this choice--don't gamble.
 -- Robert Heinlein _Time Enough For Love_ p250

http://www.donarmstrong.com              http://rzlab.ucr.edu




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#114920; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Don Armstrong <don@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #135 received at 114920@bugs.debian.org (full text, mbox):

From: Don Armstrong <don@debian.org>
To: debian-perl@lists.debian.org, 114920@bugs.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Wed, 2 Jan 2008 17:51:04 -0800
On Thu, 03 Jan 2008, Julian Mehnle wrote:
> According to a simple survey of the packages in Lenny/amd64 (main,
> contrib, non-free), 2365 of the 11757 source packages (20%!) have no
> binary package of the same name. 814 of these (7% of all) have only
> a single binary package. Wanna mass-file bugs?

No, because changing the source package name is worse than having a
stupid source package name. [The complications that it makes for bug
tracking is the major reason why changing source package names should
not be done unless required.]

> Or maybe the reason doesn't have to be all that compelling.

The reason should be compelling. While it's unfortunate that stupid
source package names have been chosen on initial uploads in the past,
I'm more concerned about the choice of source package names going
forward.


Don Armstrong

-- 
He no longer wished to be dead. At the same time, it cannot be said
that he was glad to be alive. But at least he did not resent it. He
was alive, and the stubbornness of this fact had little by little
begun to fascinate him -- as if he had managed to outlive himself, as
if he were somehow living a posthumous life.
 -- Paul Auster _City of Glass_

http://www.donarmstrong.com              http://rzlab.ucr.edu




Reply sent to Russ Allbery <rra@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Joey Hess <joeyh@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #140 received at 114920-done@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 114920-done@bugs.debian.org
Cc: debian-perl@lists.debian.org
Subject: Re: Bug#114920: [PROPOSAL] remove foolish consistency in perl module names
Date: Tue, 04 Mar 2008 19:39:16 -0800
Russ Allbery <rra@debian.org> writes:

> This is a Policy proposal that's sat in the Policy bug queue with
> wording and seconds for quite some time.  I'd like to resurrect it and
> resolve it one way or the other.

[...]

>> Proposal:
>>
>> Replace section 3.2 of the perl sub-policy included with Debian policy
>> with the following text:
>>
>>     Packages which contain perl modules should provide virtual packages
>>     that correspond to the primary module or modules in the package. The
>>     naming convention is that for module 'Foo::Bar', the package should
>>     provide 'libfoo-bar-perl'. This may be used as the package's name if
>>     the result is not too long and cumbersome. Or the package's name may
>>     be an abbreviated version, and the longer name put in the Provides
>>     field.
>>
>> Also, although they are not currently part of the formal policy, there
>> are conventions to use similar naming for java (and maybe python) module
>> packages, and if this proposal is passed, those informal policies should
>> be updated to work the same way.

The recent discussion of the resurrection of this proposal was generally
negative, with nearly everyone commenting either preferring the current
consistency to the abbreviation of package names or not seeing enough
benefit to argue for a change.

I'm going to go ahead and close this bug so that it doesn't linger in the
Policy BTS further, since I believe the consensus is against taking any
action.  (Debian Policy bugs that don't reach consensus have a tendency to
sit around forever.)  If you disagree with that consensus after reviewing
the Policy bug log, please discuss this further.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 02 Apr 2008 07:26:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 08:39:03 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.